/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: tp_RegressionOptions.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: ihi $ $Date: 2007/11/23 11:49:56 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/
#ifndef CHART2_TP_REGRESSIONOPTIONS_HXX
#define CHART2_TP_REGRESSIONOPTIONS_HXX

// SfxTabPage
#include <sfx2/tabdlg.hxx>
// CheckBox / RadioButton
#include <vcl/button.hxx>
// FixedLine
#include <vcl/fixed.hxx>

namespace chart
{

class RegressionOptionsTabPage : public SfxTabPage
{
public:
    RegressionOptionsTabPage( Window* pWindow, const SfxItemSet& rInAttrs );
	virtual ~RegressionOptionsTabPage();

	static SfxTabPage* Create( Window* pParent, const SfxItemSet& rInAttrs );

	virtual BOOL FillItemSet( SfxItemSet& rOutAttrs );
	virtual void Reset( const SfxItemSet& rInAttrs );

    DECL_LINK( DisplayOptionChecked, CheckBox* );

private:
    CheckBox    m_aCbxEquation;
    CheckBox    m_aCbxCorrelationCoeff;
//     FixedLine   m_aFlSeparator;
//     RadioButton m_aRbtNewline;
//     RadioButton m_aRbtSemicolon;
//     RadioButton m_aRbtComma;
//     RadioButton m_aRbtSlash;
};

} //  namespace chart

// CHART2_TP_REGRESSIONOPTIONS_HXX
#endif
