/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: stringlistresource.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: ihi $ $Date: 2007/11/21 15:25:56 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

// MARKER(update_precomp.py): autogen include statement, do not remove
#include "precompiled_svx.hxx"

#include "stringlistresource.hxx"

/** === begin UNO includes === **/
/** === end UNO includes === **/

#include <tools/rcid.h>

//........................................................................
namespace svx
{
//........................................................................

	/** === begin UNO using === **/
	/** === end UNO using === **/

	//====================================================================
	//= StringListResource
	//====================================================================
	//--------------------------------------------------------------------
    StringListResource::StringListResource( const ResId& _rResId )
        :Resource( _rResId )
    {
        USHORT nLocalID = 1;
        ResId aLocalID( nLocalID, *_rResId.GetResMgr() );
        while ( IsAvailableRes( aLocalID.SetRT( RSC_STRING ) ) )
        {
            String sLocalString( aLocalID );
            m_aStrings.push_back( sLocalString );
            aLocalID = ResId( ++nLocalID, *_rResId.GetResMgr() );
        }
    }

    //--------------------------------------------------------------------
    StringListResource::~StringListResource()
    {
        FreeResource();
    }

//........................................................................
} // namespace svx
//........................................................................
